(ns coderloop.decrypt
  (:use [clojure.contrib
	 [duck-streams :only [read-lines]]
	 [seq :only [find-first]]
	 [string :only [map-str]]
	 [combinatorics :only [cartesian-product]]])
  (:use rlm.shell-inspect)
  (:use [clojure [string :only [split]]])
  (:import Crypt))

(def t  "/home/r/coderloop-test/test.txt")

(defn strcat [coll]
  (apply str coll))

(def numerals [0 2 4 8 ])

(defn crypt [salt s]
  (Crypt/crypt salt s))

(defn cross-text [text]
  (let [symbols   (filter
		   (fn [s] (<= (count s) 8))
		   (split (.toLowerCase text) #"[^a-z]+"))]
    (filter
     (fn [s]
       (let [len (count s)]
	 (and
	  (>= len 5)
	  (<= len 8))))
     (map (partial apply str)
	  (cartesian-product symbols numerals symbols)))))
	  
(defn process-file [f]
  (let [file (read-lines f)
	[salt pass] (map (partial apply str) (split-at 2 (first file)))
	text (strcat (interleave (repeat \newline) (rest file)))]
    (find-first (fn [s] (= (str salt pass) (crypt salt s)))
		(cross-text text))))    


(if (command-line?)
 (println (process-file (first *command-line-args*))))
